<?php
require_once('config.php');
require_once('utilities.php');
require_once('facebook_app.php');
require_once('category.php');
FacebookApp::instance()->ensureFacebookUserLoggedInToVB();
$app = FacebookApp::instance();
$obj = $app->getVbApiInterface(); 

if(!(!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strstr($_SERVER['HTTP_X_REQUESTED_WITH'], 'XMLHttpRequest'))) {
    header('HTTP/1.1 404 Not Found');
    header('Connection: close');
    exit;
}

if( empty($_GET['action']) || empty($_GET['type']) || empty($_GET['id'])) {
    header('HTTP/1.1 404 Not Found');
    header('Connection: close');
    exit;
}

$action = $_GET['action'];
$type = $_GET['type'];
$id = $_GET['id'];

switch ($action) {
    case 'add':
        $method = 'subscription_doaddsubscription';
        break;
    case 'remove':
        $method = 'subscription_removesubscription';
        break;
}
switch ($type) {
    case 'thread':
        $params = array('threadid' => $id);
        break;
    case 'forum':
        $params = array('forumid' => $id);
        break;
}

if(!isset($method) || !isset($params)) {
    header('HTTP/1.1 404 Not Found');
    header('Connection: close');
    exit;
}
$json = json_decode($obj->call($method, $params, array()), true);
$success = (  	$json['response']['errormessage'] === 'redirect_subsremove_thread' or 
				$json['response']['errormessage'] === 'redirect_subsremove_forum' or 
				$json['response']['errormessage'] === 'redirect_subsadd_forum' or 
				$json['response']['errormessage'] === 'redirect_subsadd_thread'			);
if($success) {
	switch ($type) {
		case 'thread':
            switch ($action) {
                case 'add':
                    $thread = ThreadInfo::get($id);
                    $thread->setSubscribed(true);
                    ThreadInfo::set($thread);
                    break;
                case 'remove':
                    $thread = ThreadInfo::get($id);
                    $thread->setSubscribed(false);
                    ThreadInfo::set($thread);
                    break;
            }
			foreach(Category::filter('All', 'Threads') as $category) {
				$category->invalidate();
			}			
			break;
		case 'forum':
            switch ($action) {
                case 'add':
                    $thread = ForumInfo::get($id);
                    $thread->setSubscribed(true);
                    ThreadInfo::set($thread);
                    break;
                case 'remove':
                    $thread = ForumInfo::get($id);
                    $thread->setSubscribed(false);
                    ThreadInfo::set($thread);
                    break;
            }
			Category::registry('Forum_Threads_' . $id)->invalidate();
			break;
	}
	Category::registry('User_Profile')->invalidate();
}
echo $success; 

?>
